<?php if(!defined('PmWiki')) exit();

 /**
 *  Copyright 2010 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

/// CSSCOMPRESS - Compresses skin css files.

$RecipeInfo['csscompress']['version'] = '20110129';
$HandleActions['csscompress'] = 'HandleCssCompress';
$HandleAuth['csscompress'] = 'admin';

// if you know how to optmize this 
// please write on the talk page
SDV($CssCompressRgbPat , "/rgb\(\s?([0-9]{1,3})\s?,\s?([0-9]{1,3})\s?,\s?([0-9]{1,3})\s?\)/e");
SDV($CssCompressHexPat , "/#([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})/e");
SDV($CssCompressCommentPat , '!/\*[^*]*\*+([^/][^*]*\*+)*/!');
SDV($CssCompressTabSpaceNewline, array("\r\n", "\r", "\n", "\t"));
SDV($CssCompressSpacePat , '/\s{1,15}/');
SDV($CssCompressMoreSpace , array(
  ' {' => '{' , '{ ' => '{',
  '} ' => '}' , ' }' => '}',
  '( ' => '(' , ' (' => '(',
  ') ' => ')' , ' )' => ')',
  ' ,' => ',' , ', ' => ',',
  ' :' => ':' , ': ' => ':',
  ' ;' => ';' , '; ' => ';',
  ';}' => '}',
));
SDV($CssCompressOverWrite , true);
SDV($CssCompressPage, 'Site.CssCompress');
// complete or relative path to files
// don't forget to check file permissions
// I decided not to touch it from here
// it also accepts pmwiki anything that
// can be replaced by FmtPageName
SDV($CssCompressFiles , array(
  './pub/skins/pmwiki/pmwiki.css' => './pub/skins/pmwiki/pmwiki.cmp.css'
));

// include Site.Csscompress page
$StorePath = dirname(__FILE__)."/csscompress/wikilib.d/\$FullName";
echo $StorePath;
$where = count($WikiLibDirs);
if ($where>1) $where--;
  array_splice($WikiLibDirs, $where, 0,
    array(new PageStore($StorePath)));

function shorthex($r,$g,$b){
  $r1 = substr($r,0,1);$r2= substr($r,1,2); 
  if($r1 == $r2) $re = 1; else $re = 0;
  $g1 = substr($g,0,1);$g2= substr($g,1,2); 
  if($g1 == $g2) $ge = 1;else $ge = 0;
  $b1 = substr($b,0,1);$b2= substr($b,1,2); 
  if($b1 == $b2) $be = 1;else $be = 0;
  if($re == 1 && $ge == 1 && $be == 1 ){
    return "#".$r1.$g1.$b1 ;
  }else{
    return "#".$r.$g.$b;
  }
}

function rgb2hex($r,$g,$b){
  $r = trim($r);$g = trim($g);$b = trim($b);
  $r = dechex($r);$g = dechex($g);$b = dechex($b);
  return shorthex($r,$g,$b);
}

function csscompress($buffer) {
  global $CssCompressRgbPat,$CssCompressHexPat,$CssCompressCommentPat,
    $CssCompressTabSpaceNewline,$CssCompressSpacePat,$CssCompressMoreSpace;

  // transform rgb(73,73,74) in #737374 and short #acb colors
  $buffer = preg_replace($CssCompressRgbPat, 'rgb2hex("$1","$2","$3")',$buffer);

  // remove comments
  $buffer = preg_replace($CssCompressCommentPat, '', $buffer);

  // remove tabs, spaces, newlines, etc.
  $buffer = str_replace($CssCompressTabSpaceNewline,'', $buffer);

  // replace spaces with just one space
  $buffer = preg_replace($CssCompressSpacePat,' ', $buffer);

  // more spaces
  $buffer = str_replace(array_keys($CssCompressMoreSpace),
                        array_values($CssCompressMoreSpace), $buffer);

  return $buffer;
}

/// HANDLER

function HandleCssCompress($pagename,$auth='admin'){
  global $CssCompressOverWrite,$CssCompressFiles,
         $CssCompressPage,$PageStartFmt,$PageEndFmt;

  $page = RetrieveAuthPage($CssCompressPage, $auth, true, READPAGE_CURRENT);
  if (!$page) Abort("Insufficient permissions for Css Compress");

  $msg = MarkupToHTML($pagename,$page['text'])."<br/><br/>";
  foreach($CssCompressFiles as $k => $v){
    $infile = FmtPageName($k, $pagename);
    $outfile = FmtPageName($v, $pagename);
    if(!file_exists($infile)){
      $msg .= "$[Css file does not exist] -> ".$infile.".\n";
    }else{
      if(file_exists($outfile) &&
            $CssCompressOverWrite == false ) $writeperm = false;
      else $writeperm = true;
      if($writeperm == false)
        $msg .= "$[Css out file can't be created] -> ".$outfile."\n";
      if(!($csscontents = file_get_contents($infile))) 
        $msg .= "$[Couldn't open css file for compression] -> ".$infile.".\n";
      if(!($csscompressed = csscompress($csscontents))) 
        $msg .= "$[Couldn't compress the opened css file] -> ".$infile.".\n";
      if($csscontents != '' && $writeperm == true){
        if(!file_put_contents($outfile,$csscompressed)) 
          $msg .= "$[Couldn't open outfile] -> ".$outfile.".\n";
        else $msg .= $infile." - $[File compressed and saved in] -> ".$outfile.".\n";
      }
    }
  }

  $PageCssCompressFmt = "<div>".FmtPageName($msg, $pagename)."</div>";
  SDV($HandleCssCompressFmt, array(&$PageStartFmt, &$PageCssCompressFmt, &$PageEndFmt));
  PrintFmt($pagename, $HandleCssCompressFmt);
}
